//#include	<p18f4420.h>
//#include	<math.h>
//#include	<stdio.h>
//#include	<string.h>
#include    <xc.h>
#include    "LCD_Display_MikroC.h"
#include    <string.h>
//#include    <delays.h>

//extern  char*   DispMsg;
//extern	void	Delay_uSec( int time );
//extern	void	Delay_mSec( int time );
//extern	int abval(int val);

//void	LCD_WriteMsg( char row, char col, char *msg );
//void	LCD_Write_Data(char DATA);
//void	WriteMsgInt( char id, int val );
//void	LCD_WriteMsgFloat( char row, char col, char prec, float fval );
//void	LCD_Write_Command(char CMD);
//void	LCD_Init_Display(void);

/*
    Wait for abour 20mS
    Send the first init value (0x30)
    Wait for about 10mS
    Send second init value (0x30)
    Wait for about 1mS
    Send third init value (0x30)
    Wait for 1mS
    Select bus width (0x30 - for 8-bit and 0x20 for 4-bit)
    Wait for 1mS
 */

union LCDv8bit LCD_data;         // bitfield variable (bitwise acess)
unsigned short LCD_busy_cnt;

/******************** Write integer value to display ******************/
/*
void	WriteMsgInt( char id, int val )
	{
	sprintf( DispMsg, (rom far char*)"%04d", val );
	LCD_WriteMsg( 1, 1, DispMsg );
		}
*/
/******************** Write message to LCD display ******************/

void    Lcd_Out(char row, char col, far const char* msg) //LCD_WriteMsg( char row, char col, char *msg )
	{
	int		msgptr, msglen;
    char    cmd;
    char    DispMsg[21];
	
    if( row < 3 )
      cmd = (char)CURSOR_ADDR | (col-1) | ((row-1)<<6);
    else
      cmd = (char)CURSOR_ADDR | (col-1+20) | ((row-3)<<6);
    strcpy(DispMsg, msg );
	msglen = strlen(msg);
	Lcd_Cmd( cmd );
	for( msgptr=0; msgptr<msglen; msgptr++)
		Lcd_Data(msg[msgptr]);
	}

/*Prints character on Lcd at specified position. Both variables and literals 
 * can be passed as a character */
void Lcd_Chr(char row, char col, char out_char)
{
	char	cmd;
    if( row < 3 )
      cmd = (char)CURSOR_ADDR | (col-1) | ((row-1)<<6);
    else
      cmd = (char)CURSOR_ADDR | (col-1+20) | ((row-3)<<6);
	Lcd_Cmd( cmd );
    Lcd_Data(out_char);
}

void Lcd_Chr_Cp(char out_char)
{
    Lcd_Data(out_char);
    
}
/******************** Write float value to display ******************
1000 - 9999		No DP
100.0 - 999.9	DP2
10.00 - 99.99	DP3
0.000 - 9.999	DP4
********************************************************************/
/*
void	LCD_WriteMsgFloat( char row, char col, char	prec, float fval )
	{
	int		ival, mult;

	if(fval < 0) {
		sprintf(DispMsg, (rom far char*)"-" );
		LCD_WriteMsg( row, col, DispMsg );
		if(prec>0)
			prec--;
		}
	fval = fabs(fval);
	mult = 1;
	for( ival=1; ival<=prec; ival++ )
		mult *= 10;
	if( fval>=0 )
		ival = floor(fval);
	else
		ival = ceil(fval);
	sprintf(DispMsg, (rom far char*)"%*d", 4-prec, ival);
	LCD_WriteMsg( row, col, DispMsg );
	if(prec>0) {
		LCD_Write_Data( '.' );
		fval = mult*(fval+0.5/mult-ival);
		ival = abval(floor(fval));
		col += (strlen(DispMsg)+1);
		sprintf(DispMsg, (rom far char*)"%0*d", prec, ival);
		LCD_WriteMsg( row, col, DispMsg );
		}
	}
*/

void    Lcd_Write(char BYTE)
{
    LCD_data.all = BYTE;

    NOP;
    LCD_D7 = LCD_data.bit7;
    NOP;
    LCD_D6 = LCD_data.bit6;
    NOP;
    LCD_D5 = LCD_data.bit5;
    NOP;
    LCD_D4 = LCD_data.bit4;
#ifndef LCD_USE_8BIT_DATA
    LCD_STROBE();
    NOP;
    LCD_D7 = LCD_data.bit3;
    NOP;
    LCD_D6 = LCD_data.bit2;
    NOP;
    LCD_D5 = LCD_data.bit1;
    NOP;
    LCD_D4 = LCD_data.bit0;
#else
    NOP;
    LCD_D3 = LCD_data.bit3;
    NOP;
    LCD_D2 = LCD_data.bit2;
    NOP;
    LCD_D1 = LCD_data.bit1;
    NOP;
    LCD_D0 = LCD_data.bit0;
#endif
    LCD_STROBE();
    __delay_us(50);
}

void    Lcd_Write_Nybble(char BYTE)
{
    LCD_data.all = BYTE;

    LCD_D7 = LCD_data.bit7;
    LCD_D6 = LCD_data.bit6;
    LCD_D5 = LCD_data.bit5;
    LCD_D4 = LCD_data.bit4;
    LCD_STROBE();   
}

void	Lcd_Cmd(char CMD) //LCD_Write_Command(char CMD)
	{
	LCD_RS = LCD_CMD;
    Lcd_Write(CMD);
	}


void	Lcd_Data(char DATA)
	{
    LCD_RS = LCD_DATA;
    Lcd_Write(DATA);
	}


void	Lcd_Init() //LCD_Init_Display(void)
	{
    LCD_RS = 0; LCD_RS_DIR = 0;
    LCD_EN  = 0; LCD_EN_DIR  = 0;

    LCD_DIR_OUT();
	__delay_ms(20);             // Initial delay after power-up > 15 mSec
    LCD_RS = LCD_CMD;
	Lcd_Write_Nybble( LCD_RESET );		// 0x30 Function set 8 bit
	__delay_ms(10);				// Need at least 4.1 mSec
	Lcd_Write_Nybble( LCD_RESET );       // 0x30 Function set 8 bit
	__delay_ms(5);				// Need at least 100 uSec
	Lcd_Write_Nybble( LCD_RESET );       // 0x30 Function set 8 bit
	__delay_ms(5);
#ifdef LCD_USE_8BIT_DATA
    LCD_Write_Nybble(EIGHT_BIT);         // 0x30 
	__delay_ms(20);             // Need at least 1 mSec
//    while(LCD_Busy()){;} // wait
    LCD_Cmd(EIGHT_BIT_TWO_LINE);    // 0x38 two line 0x30 one line
			//0 0 1 DL N F x x	;DL: 1=8Bit 0=4Bit, N: 1=2Line 0=1Line, F: 1=10Dot 0=8Dot
	__delay_ms(1);              // 1 mSec recommended
#else
    Lcd_Write_Nybble(FOUR_BIT);          // 0x20
	__delay_ms(20);
//    while(LCD_Busy()){;} // wait
  #if DISPLAY_LINES == 2
    Lcd_Cmd(FOUR_BIT_TWO_LINE); // 0x28 two line
  #else
    Lcd_Cmd(FOUR_BIT_ONE_LINE); // 0x20 one line
  #endif
#endif
	__delay_us(50);
	Lcd_Cmd( DISPLAY_CTRL | DISPLAY_OFF );	//Display off
	__delay_us(50);
    Lcd_Cmd( _LCD_CLEAR );		//Display clear
	__delay_us(50);
    Lcd_Cmd(ENTRY_MODE + CURSOR_INC + DSHIFT_OFF);  // 0x04 | 0x02 | 0x00 = 0x06
    // Reset Complete
	__delay_ms(20);						//long delay

    Lcd_Cmd(DISPLAY_CTRL + DISPLAY_ON + CURSOR_ON); // 0x08 | 0x04 | 02 = 0x0e
	__delay_us(50);
    Lcd_Cmd(ENTRY_MODE + CURSOR_INC + DSHIFT_OFF);  // 0x04 | 0x02 | 0x00 = 0x06
	__delay_us(50);
//    Lcd_Cmd(0x80);       // Address DDRAM with 0 offset 80h
//	__delay_us(50);
	Lcd_Cmd( _LCD_RETURN_HOME	);		//Cursor home
	__delay_ms(2);
	}
/*
unsigned char LCD_Busy(void)
{
    if (LCD_busy_cnt >= LCD_TIMEOUT){
        LCD_busy_cnt = 1;
        return 0;                   // return -1 for time out ???????????????
    }

//    LCD_RW = LCD_RD;
    LCD_RS = LCD_CMD;
//    LCD_DIR_IN();

    LCD_ENABLE(); 
    __delay_us(1); //LCD_DELAY_1US();
    LCD_data.bit7 = LCD_D7;
    LCD_DISABLE();
    LCD_ENABLE(); 
    __delay_us(1); //LCD_DELAY_1US();
//    LCD_data.bit3 = LCD_D3_IN;
    LCD_DISABLE();

    LCD_DIR_OUT();
//    LCD_RW = LCD_WR;

    if (LCD_data.bit7 == LCD_BUSY) {
        LCD_busy_cnt++;
        return 1;
    } else {
        LCD_busy_cnt = 1;
        return 0;
    }
}
*/
